﻿Type=StaticCode
Version=2.00
@EndOfDesignText@
'v0.92
'Code module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim BoardLink As String
	Dim ServerName As String
	Dim ServerPort As Int
	ServerPort = 7890
	Dim CallBack
	Type TaskResult(Id As Int, Success As Boolean, Message As String)
	Dim DownloadFilesFolder
	Dim TasksFinishedWhilePaused As List
	Dim raf As RandomAccessFile
	Dim buffer(1024) As Byte
End Sub
Sub Initialize(Link As String, Server As String, CallbackModule As String)
	TasksFinishedWhilePaused.Initialize
	BoardLink = Link
	ServerName = Server
	B4AServerService.Tasks.Initialize
	CallBack = CallbackModule
	If File.ExternalWritable Then 
		DownloadFilesFolder = File.DirRootExternal 
	Else 
		DownloadFilesFolder = File.DirInternalCache
	End If
	raf.Initialize3(buffer, False)
End Sub
Sub SendFile (Dir As String, FileName As String) As Int
	B4AServerService.TasksCounter = B4AServerService.TasksCounter + 1
	Dim out As OutputStream
	out.InitializeToBytesArray(100)
	'Format: SEND_FILE, TaskId, name, file size, file
	writeByte(out, B4AServerService.SEND_FILE)
	writeInt(out, B4AServerService.TasksCounter)
	writeString(out, FileName)
	Dim FileOut As OutputStream
	FileOut.InitializeToBytesArray(1024)
	Dim in As InputStream
	in = File.OpenInput(Dir, FileName)
	File.Copy2(in, FileOut)
	Dim fileBytes() As Byte
	fileBytes = FileOut.ToBytesArray
	writeInt(out, fileBytes.Length)
	out.WriteBytes(fileBytes, 0, fileBytes.Length)
	Return internalSendRequest(out.ToBytesArray)
End Sub
Sub writeString(out As OutputStream, Text As String)
	Dim data() As Byte
	data = Text.GetBytes("UTF8")
	writeInt(out, data.Length)
	out.WriteBytes(data, 0, data.Length)
End Sub
Sub writeInt(out As OutputStream, Value As Int)
	raf.writeInt(Value, 0)
	out.WriteBytes(buffer, 0, 4)
End Sub
Sub writeByte(out As OutputStream, Value As Byte)
	out.WriteBytes(Array As Byte(Value), 0, 1)
End Sub
Sub ReceiveFile(FileName As String) As Int
	B4AServerService.TasksCounter = B4AServerService.TasksCounter + 1
	'Format: REQUEST_FILE, TaskId, name length, name
	Dim out As OutputStream
	out.InitializeToBytesArray(100)
	writeByte(out, B4AServerService.REQUEST_FILE)
	writeInt(out, B4AServerService.TasksCounter)
	writeString(out, FileName)
	Return internalSendRequest(out.ToBytesArray)
End Sub
Sub Shell(ShellCommand As String, Arguments As List)
	B4AServerService.TasksCounter = B4AServerService.TasksCounter + 1
	'Format: SHELL, TaskId, shell command, #args, args
	Dim out As OutputStream
	out.InitializeToBytesArray(100)
	writeByte(out, B4AServerService.Shell)
	writeInt(out, B4AServerService.TasksCounter)
	writeString(out, ShellCommand)
	If Arguments = Null OR Arguments.IsInitialized = False Then
		writeInt(out, 0)
	Else
		writeInt(out, Arguments.Size)
		For i = 0 To Arguments.Size - 1
			writeString(out, Arguments.Get(i))
		Next
	End If
	Return internalSendRequest(out.ToBytesArray)
End Sub
Sub internalSendRequest(Data() As Byte)
	If B4AServerService.server.IsInitialized Then
		B4AServerService.stopTimer.Enabled = False
	End If
	B4AServerService.Tasks.Put(B4AServerService.TasksCounter, Data)
	StartService(B4AServerService)
	Return B4AServerService.TasksCounter
End Sub
