﻿Type=Service
Version=2.00
StartAtBoot=False
@EndOfDesignText@
'v0.92
'Service module
Sub Process_Globals
	
	Dim server As ServerSocket
	Dim astream As AsyncStreams
	Dim connected As Boolean
	'timer1 is responsible for closing stalled connections
	'StopTimer breaks the connection when there are no more tasks and more than 10 seconds passed
	'wait2SecondsAndCloseConnection is responsible for closing the connections 2 seconds after we sent the STOP message
	Dim timer1, stopTimer, wait2SecondsAndCloseConnection As Timer
	Dim aliveCounter As Int
	Dim http As HttpClient
	Dim PING, SEND_FILE, REQUEST_FILE, STOP, TASK_COMPLETE, SHELL
	PING = 1: SEND_FILE = 2: REQUEST_FILE = 3 : STOP = 4: TASK_COMPLETE = 5: SHELL=6
	Dim Tasks As Map
	Dim TasksCounter As Int
	Dim TemporaryTasksList As List 'Holds TaskIds that were removed from Tasks but are not completed yet.
End Sub
Sub Service_Create
	server.Initialize(B4AServer.ServerPort, "server")
	timer1.Initialize("Timer1", 5000)
	wait2SecondsAndCloseConnection.Initialize("wait2SecondsAndCloseConnection", 2000)
	stopTimer.Initialize("StopTimer", 10000)
	http.Initialize("http")
	TemporaryTasksList.Initialize
	server.Listen
End Sub

Sub Service_Start
	ProcessNextTask
End Sub
Sub ProcessNextTask
	If Tasks.Size > 0 Then
		wait2SecondsAndCloseConnection.Enabled = False
		stopTimer.Enabled = False
		If connected = False AND IsBackgroundTaskRunning(http, 1) = False Then
			Log("Server not connected. Calling board web service.")
			SendConnectionMessageToBoard
		Else If connected = True Then
			'send task to server
			Dim	data() As Byte
			Dim TaskId As Int
			TaskId = Tasks.GetKeyAt(0)
			data = Tasks.GetValueAt(0)
			Log("Sending Task #" & TaskId)
			Tasks.Remove(TaskId)
			TemporaryTasksList.Add(TaskId)
			astream.Write(data)
		End If
	Else If connected AND Tasks.Size = 0 AND TemporaryTasksList.Size = 0 Then
		stopTimer.Enabled = True
	End If
End Sub

Sub StopTimer_Tick
	stopTimer.Enabled = False
	If connected = False Then Return
	SendMessage(Array As Byte(STOP))
	wait2SecondsAndCloseConnection.Enabled = True
	connected = False
End Sub
Sub wait2SecondsAndCloseConnection_Tick
	wait2SecondsAndCloseConnection.Enabled = False
	SetConnected(False)
End Sub
Sub server_NewConnection (Successful As Boolean, NewSocket As Socket)
	If Successful = False Then
		Log(LastException.Message)
		ToastMessageShow("Connection failed: " & LastException.Message, True)
		SetConnected(False)
	Else
		If astream.IsInitialized Then
			astream.Close
		End If
		astream.InitializePrefix(NewSocket.InputStream, True, NewSocket.OutputStream, "astream")
		SetConnected(True)
	End If
	server.Listen
End Sub
Sub astream_NewData (Buffer() As Byte)
	aliveCounter = 0
	If Buffer.Length = 0 Then Return
	Select Buffer(0)
		Case TASK_COMPLETE
			HandleTaskComplete(Buffer)
		Case REQUEST_FILE
			RequestFileArrived(Buffer) 
	End Select
End Sub
Sub astream_Error
	If connected = False Then Return
	SetConnected(False)
	Log(LastException.Message)
End Sub
Sub RequestFileArrived(Buffer() As Byte)
	Dim raf As RandomAccessFile
	raf.Initialize3(Buffer, False)
	Dim TaskId As Int
	TaskId = raf.ReadInt(1) 'skip the action byte
	Dim success As Boolean
	If raf.ReadUnsignedByte(raf.CurrentPosition) = 1 Then success = True Else success = False
	If success = False Then
		HandleTaskComplete(Buffer)
	Else
		Dim out As OutputStream
		out = File.OpenOutput(B4AServer.DownloadFilesFolder, TaskId, False)
		Dim in As InputStream
		in.InitializeFromBytesArray(Buffer, raf.CurrentPosition, Buffer.Length - raf.CurrentPosition)
		File.Copy2(in, out)
		out.Close
		Dim tr As TaskResult
		tr.Initialize
		tr.Id = TaskId
		tr.Message = "File saved: " & File.Combine(B4AServer.DownloadFilesFolder, TaskId)
		tr.success = success
		RaiseTaskCompleteEvents(tr)
		ProcessNextTask
	End If
End Sub
Sub HandleTaskComplete(Buffer() As Byte)
	If connected = False Then Return
	Dim raf As RandomAccessFile
	raf.Initialize3(Buffer, False)
	Dim TaskId As Int
	TaskId = raf.ReadInt(1) 'skip the action byte
	Dim success As Boolean
	If raf.ReadUnsignedByte(raf.CurrentPosition) = 1 Then success = True Else success = False
	Dim msg As String
	msg = BytesToString(Buffer, raf.CurrentPosition, Buffer.Length - raf.CurrentPosition, "UTF8")
	Dim tr As TaskResult
	tr.Initialize
	tr.Id = TaskId
	tr.Message = msg
	tr.success = success
	RaiseTaskCompleteEvents(tr)
	ProcessNextTask
End Sub
Sub RaiseTaskCompleteEvents (Tr As TaskResult)
	Dim i As Int
	i = TemporaryTasksList.IndexOf(Tr.Id)
	If i > -1 Then TemporaryTasksList.RemoveAt(i)
	If IsPaused(B4AServer.CallBack) Then
		B4AServer.TasksFinishedWhilePaused.Add(Tr)
	Else
		CallSub2(B4AServer.CallBack, "TaskComplete", Tr)
	End If
End Sub
Sub Timer1_Tick
	aliveCounter = aliveCounter + 1
	If aliveCounter = 12 OR (connected = False AND aliveCounter = 6) Then 
		SetConnected(False)
	End If
	SendMessage(Array As Byte(PING))
End Sub
Sub SendMessage (data() As Byte)
	If connected = False Then Return
	If astream.Write(data) = False Then SetConnected(False)
End Sub
Sub Service_Destroy
	If astream.IsInitialized Then
		astream.Close
	End If
End Sub
Sub SetConnected(value As Boolean)
	Log("Connected = " & value)
	connected = value
	timer1.Enabled = connected
	aliveCounter = 0
	If value = False Then
		stopTimer.Enabled = False
		'Raise events for cancelled tasks
		For i = 0 To Tasks.Size - 1
			Dim TaskId As Int
			TaskId = Tasks.GetKeyAt(i)
			RaiseTaskCompleteEvents(CreateCancelledTask(TaskId))
		Next
		Do While TemporaryTasksList.Size > 0
			Dim TaskId As Int
			TaskId = TemporaryTasksList.Get(0)
			'Following call removes an item from TemporaryTasksList
			RaiseTaskCompleteEvents(CreateCancelledTask(TaskId)) 
		Loop
		Tasks.Clear
		TemporaryTasksList.Clear
		If astream.IsInitialized Then astream.Close
	Else 
		ProcessNextTask
	End If
End Sub
Sub CreateCancelledTask(TaskId As Int) As TaskResult
	Dim tr As TaskResult
	tr.Initialize
	tr.Id = TaskId
	tr.Message = "Task cancelled"
	tr.Success = False
	Return tr
End Sub
Sub SendConnectionMessageToBoard
	Dim req As HttpRequest
	Dim ip As String
	ip = server.GetMyIP
	If ip = "10.0.2.15" Then ip = "127.0.0.1" '10.0.2.15 is the emulator ip.
	req.InitializeGet(B4AServer.BoardLink & "?server=" & B4AServer.ServerName & "&ip=" & ip & ":" & B4AServer.ServerPort)
	http.Execute(req, 1)
End Sub
Sub Http_ResponseSuccess (Response As HttpResponse, TaskId As Int)
	Log("Http success. Waiting for server to connect...")
	Response.Release
	timer1.Enabled = True
End Sub
Sub Http_ResponseError (Response As HttpResponse, Reason As String, StatusCode As Int, TaskId As Int)
	Log("Error connecting: " & Reason)
	If Response <> Null Then
		Log(Response.GetString("UTF8"))
		Response.Release
	End If
	SetConnected(False)
End Sub






